#ifndef THING_H
#define THING_H

#include "../caster/caster.h"
#include "../wearable/wearable.h"
#include "../wearer/wearer.h"
#include "../tempset/tempset.h"

class Thing;

///Classe Container, contenitore di oggetti (es. zaino)
/**
 * E' un TempSet di oggetti con un peso massimo per il contenuto.
 * In piu' ci sono i metodi per inserire un oggetto e toglierlo,
 * e per usarlo.
 */
class Container{
	private:
		/// Lista degli oggetti
		TempSet<Thing> ts;
};

///Classe Thing, rappresenta gli oggeti del nostro simpatico mondo
/**
 * Eredita Caster, Wearable, Container e Wearer
 * Ha un effetto per chi lo possiede, un nome, una descriione ed un peso.
 */
class Thing : public Caster, Wearable, Wearer, Container{
	private:
		/// nome dell'oggetto
		string name;
		/// descrizione dell'oggetto
		string desc;
		/// peso dell'oggetto
		int weight;
	public:
                /// Ordinamento in base al solo nome
		friend bool operator<(const Thing& sx, const Thing& dx){
			sx.name<dx.name;
		}
                                                     
};

/**
 * \example thing_test.cc
 */
#endif
